//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadXpsToPdfDll()
{
 m_hinstLib = LoadLibrary("xpstopdf.dll");
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreeXpsToPdfDll(); 
		return FALSE;
	}
	pMInputFiles = (MInputFiles *)GetProcAddress(m_hinstLib, "MInputFiles");
	if( pMInputFiles == NULL ){ 
		FreeXpsToPdfDll(); 
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreeXpsToPdfDll(); 
		return FALSE;
	}
	pMPdfSecurity = (MPdfSecurity *)GetProcAddress(m_hinstLib, "MPdfSecurity");
	if( pMPdfSecurity == NULL ){ 
		FreeXpsToPdfDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreeXpsToPdfDll(); 
		return FALSE;
	}
	pMPdfInfo = (MPdfInfo *)GetProcAddress(m_hinstLib, "MPdfInfo");
	if( pMPdfInfo == NULL ){ 
		FreeXpsToPdfDll(); 
		return FALSE;
	}
	pMRegCode = (MRegCode *)GetProcAddress(m_hinstLib, "MRegCode");
	if( pMRegCode == NULL ){ 
		FreeXpsToPdfDll(); 
		return FALSE;
	}

	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreeXpsToPdfDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}                 
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadXpsToPdfDll() == FALSE ){
		ShowMessage("The file xpstopdf.dll Loading error!");
		return;
	}

 	long id = pMBegin();
	if(id<=0){
		ShowMessage("PDF file create failed!");
		FreeXpsToPdfDll();
		return;
	}	

	//add xps files
	pMInputFiles(id,"xps.xps");
	pMInputFiles(id,"xps2.xps");

	//Trial version does not support PDF encryption!

	//Set pdf security
	long level=128;//40,128
	long permission=0;//Set restrictions for encryption.
	// 0 =	all allowed.
	// 4 =	Deny printing.
	// 8 =	Deny modification of contents.
	// 16 =	Deny copying of contents.
	// 32 =	No commenting.
	// 60 =	all disallowed.
	pMPdfSecurity(id,"password","password",level,permission);
	
	//Register your Xpstopdf SDK by the given Registration Key
	//pMRegCode(id,"AAAAAAAAAAAAAAAAAAAAAAAA");		

	//Set pdf info
	pMPdfInfo(id,"title","subject","author","keywords","creator");

	//convert
	long mode=1;//Combine all files into one pdf file
	char output[256];
	strcpy(output,"combine.pdf");
	pMConvert(id,mode,output);

	//end convert
	pMEnd(id);

	//free
	FreeXpsToPdfDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadXpsToPdfDll() == FALSE ){
		ShowMessage("The file xpstopdf.dll Loading error!");
		return;
	}

	long id = pMBegin();
	if(id<=0){
		ShowMessage("PDF file create failed!");
		FreeXpsToPdfDll();
		return;
	}	

	//add xps files
	pMInputFiles(id,"xps.xps");
	pMInputFiles(id,"xps2.xps");

	//Trial version does not support PDF encryption!

	//Set pdf security
	long level=128;//40,128
	long permission=0;//Set restrictions for encryption.
	// 0 =	all allowed.
	// 4 =	Deny printing.
	// 8 =	Deny modification of contents.
	// 16 =	Deny copying of contents.
	// 32 =	No commenting.
	// 60 =	all disallowed.
	pMPdfSecurity(id,"password","password",level,permission);
	
	//Register your Xpstopdf SDK by the given Registration Key
	//pMRegCode(id,"AAAAAAAAAAAAAAAAAAAAAAAA");		

	//Set pdf info
	pMPdfInfo(id,"title","subject","author","keywords","creator");	

	//convert
	long mode=2;//Convert one file to one pdf file
	char output[256];
	strcpy(output,"outpath");
	pMConvert(id,mode,output);

	//end convert
	pMEnd(id);

	//free
	FreeXpsToPdfDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
